/** wp_projects/asset/js/backend.js wpeo_task */

jQuery( document ).ready( function() {
	wpeo_task.init();
	
	/** Système pour gérer les loaders */
	jQuery.fn.bgLoad = function( action ) {
		return this.each( function() {
			if( action == undefined )
				jQuery(this).append('<div class="mask-loader"><div class="sk-circle"><div class="sk-circle1 sk-child"></div><div class="sk-circle2 sk-child"></div><div class="sk-circle3 sk-child"></div><div class="sk-circle4 sk-child"></div><div class="sk-circle5 sk-child"></div><div class="sk-circle6 sk-child"></div><div class="sk-circle7 sk-child"></div><div class="sk-circle8 sk-child"></div><div class="sk-circle9 sk-child"></div><div class="sk-circle10 sk-child"></div><div class="sk-circle11 sk-child"></div><div class="sk-circle12 sk-child"></div></div></div>');
			else {
				jQuery(this).find( '.mask-loader' ).remove(); 
			}
		});
	}
});



/** It's a Namespace. Use this for no conflict */
var wpeo_task = {
	grid: undefined,
	filter_class_task: [],
	array_marker: [],
	all_task: true,
	my_task: false,
	assigned_task: false,
		
	init: function() {
		this.event();
		
	},	
	
	masonry: function() {
		wpeo_task.grid = jQuery('.wpeo-project-list-task').masonry({
			itemSelector: '.wpeo-project-task',
			columnWidth: '.wpeo-project-task-size',
		});
	},
		
	event: function() {
		/** Create task event */
		jQuery( '.wpeo-project-wrap' ).on( 'click', '.wpeo-project-new-task', function( event ) { wpeo_task.create( event, jQuery( this ) ); } );
		
		/** Open dashboard event */
		jQuery( '.wpeo-project-wrap' ).on( 'click', '.wpeo-project-task-title', function() { wpeo_task.open_window( jQuery( this ) ); } );
		jQuery( '.wpeo-project-wrap' ).on( 'click', '.wpeo-task-open-dashboard', function() { wpeo_task.open_window( jQuery( this ) ); } );
		
		/** Edit title event */		
		jQuery( '.wpeo-project-wrap' ).on( 'blur', '.wpeo-project-task-title', function() { wpeo_task.edit( jQuery( this ) ); } );
		jQuery( '.wpeo-project-wrap' ).on( 'keydown', '.wpeo-project-task-title', function( e ) { if( e.which == 13 ) { jQuery( this ).blur(); }  } );
		jQuery( '.wpeo-project-wrap' ).on( 'keyup', '.wpeo-project-task-title', function( e ) { wpeo_task.preview( jQuery( this ) ); } );
						
		/** Task to trash event */
		jQuery( '.wpeo-project-wrap' ).on( 'click', '.wpeo-send-task-to-trash', function( e ) { wpeo_task.delete( jQuery( this ) ); } );
		
		/** Modifier les settings dans le dashboard d'une tâche event */
		jQuery( '.wpeo-project-wrap' ).on( 'click', '#wpeo-user-affected-to-the-task', function() { wpeo_task.edit_setting( jQuery( this ) ); } );
		jQuery( '.wpeo-project-wrap' ).on( 'click', '#wpeo-time-attected-to-the-task', function() { wpeo_task.edit_setting( jQuery( this ) ); } );
	
		/** Edit time estimated event */
		jQuery( '.wpeo-project-wrap' ).on( 'blur', '.wpeo-project-task-time-estimated', function() { wpeo_task.edit( jQuery( this ) ); } );
		
		/** Marker */
		jQuery(document).on('click', '.task-marker', function() { wpeo_task.add_marker(jQuery(this)); } );
		
		/** Send to Archive, view archive event */
		jQuery(document).on('click', '.wpeo-send-task-to-archive', function() { wpeo_task.to_archive( jQuery( this ) ); } );
		jQuery(document).on('click', '.wpeo-project-task-archive', function() { wpeo_task.view_archive(jQuery(this)); });
		
		/** Export */
		jQuery(document).on('click', '.wpeo-export', function() { wpeo_task.export( jQuery( this ) ) } );
		jQuery(document).on('click', '.wpeo-export-comment', function() { wpeo_task.export_comment( jQuery( this ) ) } );
		jQuery(document).on('click', '.wpeo-project-export-all', function( event ) { wpeo_task.export_all( event, jQuery( this ) ); } );
		
		/** Filter buttons */
		jQuery( document ).on( 'click', '.wpeo-button-all-task', function() { wpeo_task.display_all_task( jQuery( this ) ); } );
		jQuery( document ).on( 'click', '.wpeo-button-my-task', function() { wpeo_task.display_my_task( jQuery( this ) ); } );
		jQuery( document ).on( 'click', '.wpeo-button-assigned-task', function() { wpeo_task.display_assigned_task( jQuery( this ) ); } );
		
		/** Close window */
		jQuery( document ).on( 'click', '#wpeo-window-dashboard i', function() { wpeo_task.display_task(); } );
		
		/** WPShop - Charger un les tâches d'un client */
		/** Chosen WPShop */
		jQuery( '.wpeo-project-wrap .wpshop-customer-filter' ).chosen().change( function( evt, params ) { wpeo_task.change_customer_filter( evt, params ); } );
		
		//jQuery( document ).on( 'change', '.wpshop-customer-filter', function( event ) { wpeo_task.change_customer_filter( event, jQuery( this ) ); } );
		
		/** Pour recompiler le temps */
		jQuery( document ).on( 'click', '.wpeo-project-compile-time', function( event ) { wpeo_task.recompile_time( event, jQuery( this ) ); } ); 
		
		/** Liens rapide vers une tâche */
		jQuery( document ).on( 'click', '.wpeo-project-last-comment .wpeo-last-point', function( event ) { wpeo_task.go_to( event, jQuery( this ) ); } );
		
		/** Envoyer une tâche vers un autre élément */
		jQuery( document ).on( 'click', '.wpeo-send-task-to-element', function( event ) { wpeo_task.send_to_element( event, jQuery( this ) ); } );
		
		/** La date de fin d'une tâche */
		jQuery( document ).on( 'click', '.wpeo-update-due-date', function( event ) { wpeo_task.update_due_date( event, jQuery( this ) ); } );
	},
	
	/**
	 * ====================================== CREATE TASK =========================================
	 * When click on the new task button send a $.POST Request to the create_task action and 
	 * preprend to the task list the template returned by the create_task method
	 */
	create: function( event, element ) {
		event.preventDefault();
		
		/** On lance le loader */
		jQuery( '.wpeo-project-list-task' ).bgLoad();
		
		/** Construction du lien pour l'ajax */
		var url = jQuery( element ).attr( 'href' ).replace( 'admin-post.php', 'admin-ajax.php' );
		
		var data = {
			parent_id: jQuery( '.wpeo-task-post-parent' ).val(),
		};
		
		jQuery.eoajax( url, data, function() {
			/** Ajoutes le template de la tâche à Masonry */
			var $template = jQuery( this.template );
			wpeo_task.grid.prepend( $template ).masonry( 'prepended', $template);
			
			/** Si jamais le message no-task est affiché on le cache */
			jQuery( '.wpeo-project-message-no-task' ).remove();
			
			/** Si jamais la fenêtre de droite est ouverte, on la cache */
			jQuery( '#wpeo-window-dashboard' ).hide();
			
			/** On defocus un point si il est sélectionné */
			jQuery( '.wpeo-point-textarea.active' ).removeClass( 'active' );
			
			/** On enlève le loader */
			jQuery( '.wpeo-project-list-task' ).bgLoad( 'stop' );
		} );
	},
	
	/**
	 * Quand on focus le titre de la tâche ou qu'on clique sur l'engrenage à droite d'une tâche,
	 * ouvre la fenêtre à droite qui permet de voir plus d'informations sur la tâche. Pour
	 * récupérer les informations de la tâche, une requête POST est envoyé avec l'id de la tâche.
	 */
	open_window: function( element ) {
		jQuery( '#wpeo-window-dashboard *' ).css('opacity', 0);
		
		//wpeo_task.all_task = false;
		/** Remove wpeo-button-active class / Supprimes la class wpeo-button-active */
		//jQuery( '.wpeo-button-active' ).removeClass( 'wpeo-button-active' );
		
		var task_id = jQuery( element ).closest( '.wpeo-project-task' ).data( 'id' );
		
		jQuery( '.wpeo-project-task:not(.wpeo-project-task-' + task_id + ')' ).hide();
		wpeo_task.grid.masonry();
				
		jQuery( '#wpeo-window-dashboard' ).css( { 'display': 'flex', 'left': '-80px', 'opacity': 0.10 } ).bgLoad();
		jQuery( '#wpeo-window-dashboard' ).animate({ 
			'opacity': 1,
			'left': 0,
		}, 200); 
		
		var data = {
			action: 'load_dashboard_task',
			task_id: task_id,
			_wpnonce: jQuery( element ).data( 'nonce' ),
		};
		
		jQuery.eoajax( ajaxurl, data, function() {
			jQuery( '#wpeo-window-dashboard' ).html( this.template );
			jQuery( '#wpeo-window-dashboard .isDate' ).datepicker( { dateFormat: 'yy-mm-dd' } );
			
			jQuery( '#wpeo-window-dashboard *:not(.wpeo-window-background-avatar)' ).css('opacity', 0).animate({
				opacity: 1,
			}, 400);
			
			jQuery( '#wpeo-window-dashboard' ).bgLoad( 'stop' );
			var height = parseInt( jQuery( '#wpeo-window-dashboard' ).height() + 200 );
			jQuery( '#wpeo-tasks-metabox' ).css( 'height', height ); 
		} );
	},
	
	
	/**
	 * ================================== TASK EDIT =========================================
	 * Quand on défocus le titre de la tâche, envoie une requête ajaxSubmit pour modifier le titre
	 * et/ou le temps estimé.
	 */
	edit: function( element ) {
		var bloc_task 	= jQuery( element ).closest( '.wpeo-project-task' );
		var task_id 	= bloc_task.data( 'id' );
		var form 		= jQuery( element ).closest( 'form' );
		var data = {
			action: 'edit_task',
			task: {
				id: task_id,
				parent_id: jQuery( '.wpeo-task-post-parent' ).val(),
			}
		};
		
		jQuery.eoAjaxSubmit( form, data, function() {
		} );
	},
	
	/**
	 * Met à jour le nom d'une tâche en temps réel dans la dashboard
	 */
	preview: function( element ) {
		jQuery( '#wpeo-window-dashboard header h2' ).text( jQuery( element ).val() );
	},
	
	/**
	 * Une fenêtre de confirmation s'affiche demandant si on est sur de vouloir effecteur cette 
	 * action. Si l'utilisateur confirme, envoie une requête POST pour supprimer la tâche.
	 * Remove la tâche de l'interface avant la fin de la requête POST.
	 */
	delete: function( element ) {
		if ( confirm( wpeo_project_delete ) ) {
			var task_id = jQuery( element ).closest( '#wpeo-task-sub-header' ).data( 'id' );
			
			var data = {
				action: 'delete_task',
				task_id: task_id,
				_wpnonce: jQuery( element ).data( 'nonce' ),
			};
			
			jQuery( '.wpeo-project-task-' + task_id ).remove();
			wpeo_task.grid.masonry();
			jQuery( '#wpeo-window-dashboard' ).hide();
			
			jQuery.eoajax( ajaxurl, data, function() {
				jQuery( '.wpeo-button-all-task' ).click();
			} );
		}
	},
	
	/**
	 * Modifier les options d'affichage de la tâche dans le thème : Utilisateurs assignées à la
	 * tâche et temps affecté. Envoie une requête POST pour mêttre à jour les informations.
	 */
	edit_setting: function( element ) {
		var data = {
			action: 'edit_task',
		};
	
		jQuery.eoAjaxSubmit( jQuery( '#wpeo-task-option form' ), data, function() {
			
		} );
	},
	
	/**
	 * Quand on clique sur le bouton archive, envoie une requête POST à archive_task.
	 */
	to_archive: function( element ) {
		var task_id = jQuery( element ).closest( '#wpeo-task-sub-header' ).data( 'id' );
		
		var data = {
			action: 'archive_task',
			task_id: task_id,
			_wpnonce: jQuery( element ).data( 'nonce' ),
		};
		
		jQuery.eoajax( ajaxurl, data, function() {
			jQuery( '.wpeo-project-task-' + task_id ).remove();
			jQuery( '.wpeo-button-all-task' ).click();
		});
	},
	
	filter_task: function() {
		var filter_class = wpeo_task.filter_class_task.join('');
		
		var have_archive_filter = false;
		
		for( var index in wpeo_task.filter_class_task ) {
			if( wpeo_task.filter_class_task[index] == '.wpeo-archive' ) {
				have_archive_filter = true;
				break;
			}
		}
		
		jQuery('.wpeo-project-task').hide();		
		
		if(filter_class != '') {
			if( have_archive_filter ) {
				jQuery( '.wpeo-project-task' ).each(function() {
					if(jQuery(this).is(filter_class))
						jQuery(this).show();
					
				});
			}
			else {
				jQuery('.wpeo-project-task:not(.wpeo-archive)').each(function() {
					if(jQuery(this).is(filter_class))
						jQuery(this).show();
					
				});
			}
		}
		else {
			jQuery('.wpeo-project-task:not(.wpeo-archive)').show();
		}
		
		jQuery( '#wpeo-window-dashboard' ).hide();
		jQuery( '.wpeo-point-textarea.active' ).removeClass( 'active' );
		wpeo_task.grid.masonry();	
	},
	
	add_marker: function(element) {
		var task_bloc 			= jQuery( element ).closest( '.wpeo-project-task' );
		var task_id				= task_bloc.data( 'id' );
		var task_bloc_container = task_bloc.find( '.wpeo-project-task-container' );
		var marker 				= jQuery( element ); 

		if(!task_bloc.hasClass( 'wpeo-task-selected' )) {
			task_bloc.addClass( 'wpeo-task-selected' );

            /** Change the box shadow of the task to see that we selected */
			task_bloc_container.css( 'box-shadow', '0 0 0 4px #328DCF' );
			task_bloc_container.css( '-webkit-box-shadow', '0 0 0 4px #328DCF' );
			task_bloc_container.css( '-moz-box-shadow', '0 0 0 4px #328DCF' );
			task_bloc_container.css( '-o-box-shadow', '0 0 0 4px #328DCF' );

			marker.css( 'background', '#328DCF' );
			marker.css( 'border', '4px solid #fff' );
            
            /** Add task_id to the array_marker */
            this.array_marker.push(task_id);
		}
		else {
			task_bloc.removeClass('wpeo-task-selected');
            
            /** Get the index in the array for delete it */
            var index = this.array_marker.indexOf( task_id );
            
            if( index > -1 ) {
            	this.array_marker.splice( index, 1 );
            }
            
            /** Change the box shadow of the task to see that we selected */
            task_bloc_container.css( 'box-shadow', '1px 1px 5px 0px rgba(0,0,0,.2)' );
            task_bloc_container.css( '-webkit-box-shadow', '1px 1px 5px 0px rgba(0,0,0,.2)' );
            task_bloc_container.css( '-moz-box-shadow', '1px 1px 5px 0px rgba(0,0,0,.2)' );
            task_bloc_container.css( '-o-box-shadow', '1px 1px 5px 0px rgba(0,0,0,.2)' );

            marker.css( 'background', '#fff' );
            marker.css( 'border', '4px solid rgba(0,0,0,0.4)' );
		}
		
		if(this.array_marker.length == 0) {
			jQuery('.wpeo-project-export-all').addClass('disabled');
		}
		else {
			jQuery('.wpeo-project-export-all').removeClass('disabled');
		}
	},
		
	export: function( element ) {
		var task_id = jQuery( element ).closest(' #wpeo-task-sub-header' ).data( 'id' );

		var data = {
			action: 'export_task',
			id: task_id,
			_wpnonce: jQuery( element ).data( 'nonce' ),
		};
		
		jQuery.eoajax( ajaxurl, data, function( ) {
			wpeo_task.download_export( this.url_to_file, false );
		});
	},
	
	export_comment: function( element ) {
		var task_id = jQuery( element ).closest(' #wpeo-task-sub-header' ).data( 'id' );

		var data = {
			action: 'export_task',
			id: task_id,
			comment: true,
			_wpnonce: jQuery( element ).data( 'nonce' ),
		};
		
		jQuery.eoajax( ajaxurl, data, function( ) {
			wpeo_task.download_export( this.url_to_file, false );
		});
	},
	
	export_all: function( event, element ) {
		event.preventDefault();
		
		if( !jQuery( element ).hasClass( 'disabled' ) ) {
			var data = {
				action: 		'export_all_task',
				_wpnonce:			jQuery( element ).data( 'nonce' ),
				array_task_id: 	this.array_marker
			};
	
			jQuery.eoajax( ajaxurl, data, function() {
				wpeo_task.download_export( this.url_to_file, true );
			});
		}
	},
	
	download_export: function(url_to_file, deselect) {
		var url = jQuery('<a href="' + url_to_file + '" download="Export"></a>');
		jQuery('.wpeo-project-wrap').append(url);
		url[0].click();
		url.remove();
		
		if(deselect) {
			jQuery('.wpeo-task-selected').each(function() {
				jQuery(this).find('.task-marker').click();
			});
		}
	},
	
	display_all_task: function( element ) {
		jQuery( '.wpeo-project-task.wpeo-project-task-customer' ).remove();
		wpeo_task.all_task = true;
		wpeo_task.my_task = false;
		wpeo_task.assigned_task = false;
		
		jQuery( '.wpeo-button-active' ).removeClass( 'wpeo-button-active' );
		jQuery( element ).addClass( 'wpeo-button-active' );
		
		jQuery( '.wpeo-project-task' ).hide();
		jQuery( '.wpeo-project-task:not(.wpeo-archive)' ).show();
		wpeo_task.filter_task();
		wpeo_task.grid.masonry();

		jQuery( '#wpeo-window-dashboard' ).hide();
		jQuery( '.wpeo-point-textarea.active' ).removeClass( 'active' );
	},
	
	display_my_task: function( element ) {
		jQuery( '.wpeo-project-task.wpeo-project-task-customer' ).remove();
		wpeo_task.all_task = false;
		wpeo_task.my_task = true;
		wpeo_task.assigned_task = false;
		
		jQuery( '.wpeo-button-active' ).removeClass( 'wpeo-button-active' );
		jQuery( element ).addClass( 'wpeo-button-active' );
		
		wpeo_task.filter_task();
		jQuery( '.wpeo-project-task:not(.wpeo-my-task)' ).hide();
		
		wpeo_task.grid.masonry();

		jQuery( '#wpeo-window-dashboard' ).hide();
		jQuery( '.wpeo-point-textarea.active' ).removeClass( 'active' );
	},
	
	display_assigned_task: function( element ) {
		jQuery( '.wpeo-project-task.wpeo-project-task-customer' ).remove();
		wpeo_task.all_task = false;
		wpeo_task.my_task = false;
		wpeo_task.assigned_task = true;
		
		jQuery( '.wpeo-button-active' ).removeClass( 'wpeo-button-active' );
		jQuery( element ).addClass( 'wpeo-button-active' );
		
		wpeo_task.filter_task();
		jQuery( '.wpeo-project-task:not(.wpeo-affected-task)' ).hide();
		
		wpeo_task.grid.masonry();

		jQuery( '#wpeo-window-dashboard' ).hide();
		jQuery( '.wpeo-point-textarea.active' ).removeClass( 'active' );
	},
	
	/**
	 * Enlève tous les filtres sélectionnées et refresh les tâches pour ensuite refresh masonry
	 */
	clear_filter: function() {
		wpeo_task.all_task = false;
		wpeo_task.my_task = false;
		wpeo_task.assigned_task = false;
		jQuery( '.search-choice-close' ).click();
		
		wpeo_task.filter_class_task.length = 0;
		wpeo_task.filter_task();
		
		wpeo_task.grid.masonry();
	},
	
	/**
	 * Quand on change d'option dans la liste déroulante, décoches tous les filtres actuelles,
	 * cache la fenêtre de droite si elle est affichée et envoie une requête AJAX qui vas récupérer
	 * toutes les tâches liée au customer pour ensuite les afficher en JS.
	 */
	change_customer_filter: function( event, params ) {	
		if ( params.selected != undefined ) {
			jQuery( '.wpeo-button-active' ).removeClass( 'wpeo-button-active' );
			jQuery( '.wpeo-project-task:not(.wpeo-project-task-customer)' ).hide();
			jQuery( '#wpeo-window-dashboard' ).hide();
			
			var data = {
				action: 'load_task_customer',
				customer_id: params.selected,
				_wpnonce: jQuery( '.wpshop-customer-filter option[value="'+params.selected+'"]' ).data( 'nonce' ),
			};
			
			jQuery.eoajax( ajaxurl, data, function() {
				var $template = jQuery( this.template );
				wpeo_task.grid.prepend( $template ).masonry( 'prepended', $template );
			} );
			
		}
		
		if ( params.deselected != undefined ) {
			jQuery( '.wpeo-project-task-customer-' + params.deselected ).remove();

			// Si aucune tâche, on remet les anciennes
			if ( jQuery( '.wpshop-customer-filter option:selected').length <= 0 ) {
				jQuery( '.wpeo-project-task-customer' ).remove();
				jQuery( '.wpeo-project-task' ).show();
			}
		}
	       
		wpeo_task.grid.masonry();			        
	},
	
	/**
	 * Quand on clique sur ce bouton, lance une requête AJAX qui vas recompilé le temps de toutes
	 * les tâches présentes dans la base de donnée 
	 */
	recompile_time: function( event, element ) {
		jQuery( element ).bgLoad();
		
		var data = {
			action: 'compile_time',
			_wpnonce: jQuery( element ).data( 'nonce' ),
		};
		
		jQuery.eoajax( ajaxurl, data, function() {
			jQuery( element ).bgLoad( 'stop' );
		} );
	},
	
	/**
	 * Quand on choisi une catégorie, ou un utilisateur, ou un utilisateur WPShop, cette méthode
	 * envoie une requête AJAX afin de savoir le temps total passé/estimé sur les tâches affichées.
	 */
	calcul_time: function() {
	
	},
	
	go_to: function( event, element ) {
		var user_id = jQuery( element ).data( 'user' );
		var point_id = jQuery( element ).data( 'id' );
		
		jQuery( '.wpshop-customer-filter > option[value="' + user_id + '"]' ).prop( 'selected', true );
		jQuery( '.wpshop-customer-filter' ).change();
	},
	
	display_task: function() {
		if ( wpeo_task.all_task ) {
			jQuery( '.wpeo-button-all-task' ).click();
		}
		else if ( wpeo_task.my_task ) {
			jQuery( '.wpeo-button-my-task' ).click();
		}
		else if ( wpeo_task.assigned_task) {
			jQuery( '.wpeo-button-assigned-task' ).click();
		}
	},
	
	send_to_element: function( event, element ) {
		jQuery.eoAjaxSubmit( jQuery( element ).closest( 'form' ), { action: 'send_task_to_element' }, function() {
			jQuery( '.wpeo-project-task-' + this.task_id ).remove();
			jQuery( '#wpeo-window-dashboard' ).hide();
		} );
		return false;
	},
	
	update_due_date: function( event, element ) {
		jQuery.eoAjaxSubmit( jQuery( element ).closest( 'form' ), { action: 'update_due_date' }, function() {
		} );
		return false;
	}
	
};


	