/** wpeo_point/asset/js/backend.js */

jQuery( document ).ready( function() {
	wpeo_point.init();
});
	
/** It's a Namespace. Use this for no conflict */
var wpeo_point = {
	init: function() {
		this.refresh_flextext();
		this.refresh_sortable();
		
		if(wpeo_task)
			wpeo_task.masonry();
				
		this.event();
	},	
		
	event: function() {
		/** Créer un point */
		jQuery( '.wpeo-project-wrap' ).on( 'keyup', '.wpeo-add-point textarea', function(event) { wpeo_point.key_up(event, jQuery(this)); } );
		jQuery( '.wpeo-project-wrap' ).on( 'click', '.wpeo-task-add-new-point', function() { wpeo_point.create( jQuery( this ) ); } );
		
		jQuery( '.wpeo-project-wrap' ).on( 'click', '.wpeo-send-point-to-trash', function() { wpeo_point.delete( jQuery( this ) ); } );
		
		jQuery( '.wpeo-project-wrap' ).on( 'click', '.wpeo-done-point', function( e ) { wpeo_point.switch_completed( e, jQuery( this ) ); } );
		jQuery( '.wpeo-project-wrap' ).on( 'blur', '.wpeo-point-input .wpeo-point-textarea', function() { wpeo_point.edit( jQuery( this ) ); } );
		jQuery( '.wpeo-project-wrap' ).on( 'keyup', '.wpeo-point-input .wpeo-point-textarea', function() { wpeo_point.preview( jQuery( this ) ); } );
		jQuery( '.wpeo-project-wrap' ).on( 'click', '.wpeo-point-input .wpeo-point-textarea', function() { wpeo_point.open_window( jQuery( this ) ); } );
		
		jQuery( '.wpeo-project-wrap' ).on( 'click', '.wpeo-task-point-use-toggle p', function( event ) { wpeo_point.toggle_completed( event, jQuery( this ) ); } );
		
		jQuery( document ).on( 'click', '#wpeo-task-form-point-time .wpeo-open-point-time-form', function() { wpeo_point.update_form( jQuery( this ), true ); } );
		jQuery( document ).on( 'click', '#wpeo-task-form-point-time .wpeo-submit', function() { wpeo_point.create_point_time( jQuery( this ) ); } );
		jQuery( document ).on( 'click', '.wpeo-point-comment .wpeo-submit', function() { wpeo_point.edit_point_time_form( jQuery( this ) ); } );
		jQuery( document ).on( 'click', '.wpeo-send-point-time-to-trash', function( event ) { wpeo_point.delete_point_time( event, jQuery( this ) ); } );
		jQuery( document ).on( 'click', '.wpeo-point-time-edit-btn', function( event ) { wpeo_point.edit_point_time( event, jQuery( this ) ); });
	
		jQuery( document ).on( 'click', '.wpeo-send-point-to-task', function( event ) { wpeo_point.send_point_to_task( event, jQuery( this ) ); } );
		jQuery( document ).on( 'keypress', '#wpeo-window-dashboard #wpeo-point-option input[type="text"]', function( event ) { wpeo_point.key_up_text_send_point( event, jQuery( this ) ); } );
	
		/** Pagination dernier commentaire */
		jQuery( document ).on( 'click', '.wpeo-project-last-comment .last-comment-page', function( event ) { wpeo_point.pagination( event, jQuery( this ) ); } );
	},
	
	key_up: function(event, element ) {
		var task_bloc = jQuery( element ).closest( '.wpeo-project-task' );

		if( event.which == 13 ) {
//			jQuery('.wpeo-project-wrap').off('keypress', '.wpeo-add-point textarea');
//			task_bloc.find('.wpeo-task-add-new-point').click();
//			return false;
		}
		else {		
			if(jQuery( element ).val().length == 0) {
				task_bloc.find('.wpeo-task-add-new-point').css('opacity', 0.4);
			}
			else {
				task_bloc.find('.wpeo-task-add-new-point').css('opacity', 1);
			}
		}
	},
	
	/**
	 * Quand on clique sur le dashicons (+), envoie un ajaxSubmit pour crée le point.
	 * Désactive cette event jusqu'a la fin de cette requête pour ne pas spammer le bouton.
	 */
	create: function( element ) {
		var form = jQuery( element ).closest( 'form' );
		var bloc_task = jQuery( element ).closest( '.wpeo-project-task' );
		
		jQuery( '.wpeo-project-wrap' ).off( 'click', '.wpeo-task-add-new-point' );
		
		bloc_task.bgLoad();
		
		jQuery.eoAjaxSubmit( form, { 'action': 'create_point' }, function() {			
			bloc_task.bgLoad( 'stop' );
			
			/** Réactive les events */
			jQuery( '.wpeo-project-wrap' ).on( 'click', '.wpeo-task-add-new-point', function() { wpeo_point.create( jQuery( this ) ); } );
			jQuery( '.wpeo-project-wrap' ).on( 'keypress', '.wpeo-add-point textarea', function( event ) { wpeo_point.key_up( event, jQuery( this ) ); } );
			
			jQuery( element ).closest( '.wpeo-project-task' ).find( '.wpeo-task-point:first' ).append( this.template );
			bloc_task.find( '.wpeo-task-li-point:last' ).css( { 'opacity': 0, 'left': -20 } ).animate( {
				opacity: 	1,
				left: 		0
			}, 300 );
			
			/** On met à jour l'interface */
			wpeo_point.refresh_flextext();
			wpeo_point.refresh_sortable();
			form.clearForm();
			wpeo_task.grid.masonry();
		} );
	},
	
	/**
	 * Quand on clique sur supprimer un point. Demande une confirmation puis envoie une requête
	 * POST et remove le point. On met également à jour l'interface au niveau des minutes.
	 */
	delete: function( element ) {
		if ( confirm ( wpeo_project_delete_comment ) ) {
			var point_bloc 	= jQuery( element ).closest( '.wpeo-task-li-point' );
			var task_bloc	= point_bloc.closest( '.wpeo-project-task' );
			var point_id	= point_bloc.data( 'id' );
			var object_id	= point_bloc.closest( '.wpeo-task-point' ).find( '.wpeo-object-id' ).val();
			var completed 	= point_bloc.find( '.wpeo-done-point' ).is( ':checked' );
			
			/** Animation quand le point disparait */
			point_bloc.animate( {
				opacity: 	0,
				left: 		"-=20",
				height: 	0,
			}, 300, function() {
				jQuery( this ).hide();
			} );
			
			var data = {
				action: 'delete_point',
				object_id: object_id,
				point_id: point_id,
				_wpnonce: jQuery( element ).data( 'nonce' ),
			};
						
			jQuery.eoajax( ajaxurl, data, function() {
				jQuery( '.wpeo-project-task-' + object_id + ' .wpeo-project-task-time' ).text( this.task.option.time_info.elapsed );
				
				if( completed ) {
					var count_completed = task_bloc.find( '.wpeo-task-count-completed' ).text();
					count_completed--;
					task_bloc.find( '.wpeo-task-count-completed' ).text( count_completed );
				}
				
				wpeo_task.grid.masonry();
				jQuery( '#wpeo-window-dashboard' ).hide();
			} );
		}
	},
	
	edit: function( element ) {
		var form = jQuery( element ).closest( '.form' );
		
		jQuery.eoAjaxSubmit( form, { 'action': 'edit_point' }, function() {
		} );
	},
	
	preview: function( element ) {
		jQuery( '#wpeo-window-dashboard .wpeo-point-title' ).text( jQuery( element ).val() );
	},
	
	open_window: function( element ) {
		jQuery( '#wpeo-window-dashboard *' ).css('opacity', 0);

		jQuery( '.wpeo-point-textarea.active' ).removeClass( 'active' );

		jQuery( element ).addClass( 'active' );
		//
		//wpeo_task.all_task = false;
		/** Remove wpeo-button-active class / Supprimes la class wpeo-button-active */
		//jQuery( '.wpeo-button-active' ).removeClass( 'wpeo-button-active' );
		
		var bloc_task 	= jQuery( element ).closest( '.wpeo-project-task' );
		var task_id 	= bloc_task.data( 'id' );
		var point_id 	= jQuery(element).closest( '.wpeo-task-li-point' ).data( 'id' );
		
		jQuery( '#wpeo-window-dashboard' ).css( { 'display': 'flex', 'left': '-80px', 'opacity': 0.10 } ).bgLoad();
		jQuery( '#wpeo-window-dashboard' ).animate({ 
			'opacity': 1,
			'left': 0,
		}, 200); 
		
		jQuery( '.wpeo-project-task:not(.wpeo-project-task-' + task_id + ')' ).hide();
		wpeo_task.grid.masonry();
		
		var data = {
			action: 'load_dashboard_point',
			task_id: task_id,
			point_id: point_id,
			_wpnonce: jQuery( element ).data( 'nonce' ),
		};
		
		jQuery.eoajax( ajaxurl, data, function() {
			jQuery( '#wpeo-window-dashboard' ).html( this.template );
			//jQuery( '#wpeo-window-dashboard' ).bgLoad( 'stop' );
			jQuery( '#wpeo-window-dashboard *' ).css('opacity', 0).animate({
				opacity: 1,
			}, 400);
			jQuery( '#wpeo-window-dashboard' ).attr( 'data-id', point_id );
						
//			jQuery( '' ).suggest( ajaxurl + '?action=load_task');
			
			if( !wpeo_task.all_task )
				jQuery( this ).show();
			
			jQuery( '#wpeo-window-dashboard .isDate' ).datepicker( { dateFormat: 'yy-mm-dd' } );
			
			var height = parseInt( jQuery( '#wpeo-window-dashboard' ).height() + 200 );
			jQuery( '#wpeo-tasks-metabox' ).css( 'height', height ); 
		} );
	},
	
	edit_order: function( element ) {
		var order_point_id 	= [];
		var object_id 		= jQuery(element).find('.wpeo-object-id').val();
		
		jQuery(element).find('.wpeo-task-li-point').each(function() {
			order_point_id.push( jQuery( this ).data('id' ) );
		});
		
		var data = {
			action: 'edit_order_point',
			object_id: object_id,
			order_point_id: order_point_id,
		};
		
		jQuery.post( ajaxurl, data, function() {
			wpeo_task.grid.masonry();			
		});
		
		
	},
	
	switch_completed: function( e, element ) {	
		wpeo_point.edit( element );
		
		var bloc_task = jQuery( element ).closest( '.wpeo-project-task' );
		var bloc = jQuery( element ).closest( 'form' );
		var count_completed = bloc_task.find( '.wpeo-task-count-completed' ).text();
		
		if( jQuery( element ).is( ':checked' ) ) {
			bloc_task.find( '.wpeo-task-point-completed:first' ).append( bloc );
			count_completed++;
		}
		else {
			bloc_task.find( '.wpeo-task-point:first' ).append( bloc );
			count_completed--;
		}
		
		bloc_task.find( '.wpeo-task-count-completed' ).text(count_completed);
		wpeo_task.grid.masonry();
		wpeo_point.refresh_sortable();
	},
	
	toggle_completed: function( event, element ) {
		event.preventDefault();
		
		 jQuery( element ).find('.wpeo-point-toggle-arrow').toggleClass('dashicons-plus dashicons-minus');
         jQuery( element ).closest('.wpeo-task-point-use-toggle').find('ul:first').toggle(200, function() {
        	 wpeo_task.grid.masonry();
         });
	},

	refresh_flextext: function() {
		jQuery( '.wpeo-project-wrap .wpeo-point-input > textarea' ).flexText();
	},
	
	refresh_sortable: function() {
		jQuery( '.wpeo-project-wrap .wpeo-task-point-sortable' ).sortable( {
			handle: '.dashicons-screenoptions',
			items: '.wpeo-task-point-sortable',
			update: function() {
				wpeo_point.edit_order( jQuery( this ) );
			}
		} );
	},
	
	update_form: function( element, open ) {
	},
	
	create_point_time: function(element) {
		var point_id = jQuery(element).closest('form').find('.wpeo-point-id').val();
		
		jQuery( '#wpeo-window-dashboard' ).bgLoad();
		
		jQuery.eoAjaxSubmit( jQuery(element).closest('form'), { action: 'create_point_time' }, function() {
			jQuery( '#wpeo-window-dashboard' ).bgLoad( 'stop' );
			jQuery( '.wpeo-point-no-comment' ).hide(); 
			if( this.edit ) {
				jQuery('.wpeo-point-comment-' + this.point_time_id).replaceWith( this.template );
			}
			else {
				jQuery( '#wpeo-task-point-history' ).prepend( this.template );
			}
			jQuery('.wpeo-project-task-' + this.task.id + ' .wpeo-project-task-time').text( this.task.option.time_info.elapsed );
			jQuery('.wpeo-project-task-' + this.task.id + ' .wpeo-task-point-' + point_id + ' .wpeo-time-in-point').text( this['task']['point'][point_id]['option']['time_info']['elapsed'] );
			
			jQuery(element).closest('form').find('.wpeo-point-time-id').val( 0 );
			jQuery(element).closest('form').find('.wpeo-point-comment').val( '' );
			
			jQuery( '#wpeo-window-dashboard .wpeo-point-elapsed-time' ).text( this['task']['point'][point_id]['option']['time_info']['elapsed'] );
			var current_number_point_time = jQuery( '#wpeo-window-dashboard .wpeo-point-list-point-time' ).text();
			current_number_point_time++;
			jQuery( '#wpeo-window-dashboard .wpeo-point-list-point-time' ).text( current_number_point_time );
			
			wpeo_point.update_form( jQuery( this ), false );
		});
	},
	
	edit_point_time_form: function( element ) {
		jQuery( '#wpeo-window-dashboard' ).bgLoad();
		
		jQuery.eoAjaxSubmit( jQuery(element).closest('form'), { action: 'create_point_time' }, function() {
			jQuery( '#wpeo-window-dashboard' ).bgLoad( 'stop' );
			jQuery( '.wpeo-point-no-comment' ).hide(); 
			
			jQuery('.wpeo-point-comment-' + this.point_time_id).replaceWith( this.template );
		
			jQuery('.wpeo-project-task-' + this.task.id + ' .wpeo-project-task-time').text( this.task.option.time_info.elapsed );
			jQuery('.wpeo-project-task-' + this.task.id + ' .wpeo-task-point-' + point_id + ' .wpeo-time-in-point').text( this['task']['point'][point_id]['option']['time_info']['elapsed'] );
			
			jQuery( '#wpeo-window-dashboard .wpeo-point-elapsed-time' ).text( this['task']['point'][point_id]['option']['time_info']['elapsed'] );
			var current_number_point_time = jQuery( '#wpeo-window-dashboard .wpeo-point-list-point-time' ).text();
			current_number_point_time++;
			jQuery( '#wpeo-window-dashboard .wpeo-point-list-point-time' ).text( current_number_point_time );
		});
	},
	
	edit_point_time: function( event, element ) {
		event.preventDefault();
		jQuery( '#wpeo-window-dashboard' ).bgLoad();
		
		var point_time_id = jQuery( element ).closest( '.wpeo-point-comment' ).data( 'id' );
		
		var data = {
			action: 'get_point_time',
			_wpnonce: jQuery( element ).data( 'nonce' ),
			point_time_id:	point_time_id,
		};
		
		jQuery.eoajax( ajaxurl, data, function() {
			jQuery( '#wpeo-window-dashboard' ).bgLoad( 'stop' );
			
			jQuery( '#wpeo-window-dashboard .wpeo-point-comment-' + this.point_time_id ).replaceWith( this.template );
		});
	},
	
	delete_point_time: function(event, element) {
		event.preventDefault();
		
		if( confirm( wpeo_project_delete_comment_time ) ) {
			
			var point_id = jQuery( element ).closest( '#wpeo-window-dashboard' ).data( 'id' );
			var point_time_id = jQuery( element ).closest( '.wpeo-point-comment' ).data( 'id' );
			jQuery( element ).closest( 'ul' ).remove();
			
			var data = {
				action: 'delete_point_time',
				_wpnonce: jQuery( element ).data( 'nonce' ),
				point_time_id: point_time_id,
			};
			
			jQuery.eoajax( ajaxurl, data, function() {
				jQuery('.wpeo-project-task-' + this.task.id + ' .wpeo-task-point-' + point_id + ' .wpeo-time-in-point').text( this['task']['point'][point_id]['option']['time_info']['elapsed'] );
				
				jQuery( '.wpeo-project-task-' + this.task.id + ' .wpeo-project-task-time' ).text( this.task.option.time_info.elapsed );
				jQuery( '#wpeo-window-dashboard .wpeo-point-elapsed-time' ).text( this['task']['point'][point_id]['option']['time_info']['elapsed'] );
				
				var current_number_point_time = jQuery( '#wpeo-window-dashboard .wpeo-point-list-point-time' ).text();
				current_number_point_time--;
				jQuery( '#wpeo-window-dashboard .wpeo-point-list-point-time' ).text( current_number_point_time );
			});
		}
	},
	
	send_point_to_task: function( event, element ) {
		jQuery.eoAjaxSubmit( jQuery( element ).closest( 'form' ), { action: 'send_point_to_task' }, function() {
			jQuery( '.wpeo-project-task-' + this.to_task_id + ' .wpeo-task-point:first').append( this.template );
			jQuery( '.wpeo-project-task-' + this.current_task_id + ' .wpeo-task-point-' + this.point_id ).remove();
			
			jQuery( '.wpeo-project-task-' + this.to_task_id + ' .wpeo-project-task-time').html( this.task_time );
			jQuery( '.wpeo-project-task-' + this.current_task_id + ' .wpeo-project-task-time').html( this.current_task_time );
			
			wpeo_point.refresh_flextext();
			wpeo_point.refresh_sortable();
		} );
		
		return false;
	},
	
	key_up_text_send_point: function( event, element ) {
		if( event.which == 13 ) {
			jQuery( '#wpeo-window-dashboard #wpeo-point-option .wpeo-send-point-to-task' ).click();
			event.preventDefault();
			return false;
		}
	},
	
	pagination: function( event, element ) {
		event.preventDefault();
		
		var page_id = jQuery( element ).data( 'page' );
		jQuery( '.wpeo-project-last-comment' ).bgLoad();
		
		var data = {
			'action': 'load_last_comment',
			'page': page_id,
		};
		
		jQuery.eoajax( ajaxurl, data, function() { 
			jQuery( '.wpeo-project-last-comment' ).replaceWith( this.template );
		} );
	}
};