<?php

class wpeo_project_data_transfert_ctr_01 {
	public function __construct() {
		add_action('admin_menu', array($this, 'callback_admin_menu'));
	}
	
	public function callback_admin_menu() {
		add_submenu_page( 'wpeomtm-dashboard', __( 'Data transfert', 'task-manager' ), __( 'Data transfert', 'task-manager' ), 'manage_options', 'wpeo-project-data-transfert', array( &$this, 'callback_submenu_page' ) );
	}
	
	public function callback_submenu_page() {
		$this->transfert_data();
		$this->delete_old_meta();
		
		echo 'Transfert terminée';
	}
	
	private function transfert_data() {
		global $task_ctr_01;
		
		/** Get all post with type : 'wpeo-tasks' */
		$args = array(
			'posts_per_page' 	=> -1,
			'post_type'			=> 'wpeo-tasks',
			'post_status'		=> array('publish', 'archive'),
		);
		
		$array_post = get_posts($args);
		
		if(!empty($array_post)) {
			foreach($array_post as $post) {
				/** Edit task */
				$task_mdl = $task_ctr_01->show($post->ID);
				$task_mdl->type = 'wpeo-task';
				
				/** Get post meta */
				$task_mdl = $this->fill_meta($task_mdl);
				
				$total_time_in_point = $this->save_meta_comment($task_mdl->id, $task_mdl->option['task_info']['order_point_id']);
				$task_mdl->option['time_info']['elapsed'] = $total_time_in_point;
				
				$task_ctr_01->create($task_mdl);
			}
		}
	}
	
	private function fill_meta($task_mdl) {
		$postmeta = get_post_meta($task_mdl->id);
		
		$task_setting = array();
		if(!empty($postmeta['_wpeomtm_task_setting'][0])) {
			$task_setting = maybe_unserialize($postmeta['_wpeomtm_task_setting'][0]);
		}
		
		$meta = array(
			'front_info' => array(
				'display_time' => !empty($task_setting['time']) ? $task_setting['time'] : 0,
				'display_user' => !empty($task_setting['user']) ? $task_setting['user'] : 0,
			),
			'user_info' => array(
				'affected_id'  	=> maybe_unserialize($postmeta['wpeo_task_users'][0]),
				'writer_id'		=> $postmeta['wpeo_project_task_user_write'][0],
			),
			'time_info' => array(
				'estimated' 	=> !empty($postmeta['wpeo_task_estimated_time'][0]) ? $postmeta['wpeo_task_estimated_time'][0] : 0,
			),
			'task_info' => array(
				'order_point_id' => array(),
			),
		);
		
		/** Rework order_point_id */
		$order_point_id = array();
		/** Get comments with comment_post_ID = $task_mdl->id and comment_parent = 0 */
		$args = array(
			'post_id' 	=> $task_mdl->id,
			'parent'	=> 0,
			'status'	=> '-34070',
			'fields'	=> 'ids',
		);
		$array_point_id = get_comments($args);
		$old_order_point_id = !empty($postmeta['wpeo_points_order'][0]) ? maybe_unserialize($postmeta['wpeo_points_order'][0]) : array();
		
		
		if(!empty($old_order_point_id)) {
			foreach($old_order_point_id as $old_point_id) {
				if(in_array($old_point_id, $array_point_id)) {
					$order_point_id[] = $old_point_id;
				}
								
				$key = array_search($old_point_id, $array_point_id);
				unset($array_point_id[$key]);
			}
		}
		
		
		$order_point_id = array_merge($order_point_id, $array_point_id);
		$meta['task_info']['order_point_id'] = $order_point_id;
		$task_mdl->option = array_replace_recursive($task_mdl->option, $meta);
		
		return $task_mdl;
	}
	
	private function save_meta_comment($task_id, $order_point_id) {
		$point_ctr = new point_ctr_01();
		$total_time_in_point = 0;
				
		if(!empty($order_point_id)) {
			foreach($order_point_id as $point_id) {
				$point_mdl = $point_ctr->show($point_id);
				$total_time_in_point_time = $this->save_point_time($task_id, $point_mdl->id);
				
				$commentmeta = get_comment_meta($point_mdl->id, 'wpeo_points_done', true);
				$meta = array(
					'point_info' => array(
						'completed' => $commentmeta,
					),
					'time_info' => array(
						'elapsed' => $total_time_in_point_time,
					),
				);
				$total_time_in_point += (int)$total_time_in_point_time;
				$point_mdl->option = array_replace_recursive($point_mdl->option, $meta);
				
				$point_ctr->update($point_mdl);
			}
		}
		
		return $total_time_in_point;
	}
	
	private function save_point_time($task_id, $point_id) {
		$point_time_ctr 	= new point_time_ctr_01();
		$list_point_time 	= $point_time_ctr->index($task_id, array('status' => '-34070', 'parent' => $point_id));
		$total_time_in_point_time = 0;
		if(!empty($list_point_time)) {
			foreach($list_point_time as $point_time) {
				$point_time = $this->save_meta_point_time($point_time);
				$point_time_ctr->update($point_time);
				$total_time_in_point_time += (int)$point_time->option['time_info']['elapsed'];
			}
		}
		
		return $total_time_in_point_time;
	}
	
	private function save_meta_point_time($point_time) {
		$commentmeta = get_comment_meta($point_time->id, 'wpeo_points_time', true);
		
		$meta = array(
			'time_info' => array(
				'elapsed' => $commentmeta,
			),
		);
		$point_time->option = array_replace_recursive($point_time->option, $meta);
		
		return $point_time;
	}

	private function delete_old_meta() {
		/** Task */
		delete_post_meta_by_key('wpeo_task_users');
		delete_post_meta_by_key('wpeo_points_order');
		delete_post_meta_by_key('wpeo_project_task_user_write');
		delete_post_meta_by_key('wpeo_task_estimated_time');
		delete_post_meta_by_key('_wpeomtm_task_planing');
		delete_post_meta_by_key('_wpeomtm_task_setting');
		
		/** Point */
		
		/** Point Time */
	}
}