<?php
/**
 * Plugin Name: Task Manager
 * Description: Quick and easy to use, manage all your tasks and your time with this plugin. / Rapide et facile à utiliser, gérer toutes vos tâches et votre temps avec cette extension.
 * Version: 1.3.0.1
 * Author: Eoxia <dev@eoxia.com>
 * Author URI: http://www.eoxia.com/
 * License: GPL2 or later
 * License URI: http://www.gnu.org/licenses/gpl-2.0.html
 * Text Domain: task-manager
 * Domain Path: /language
 */

/**
 * Bootstrap file for plugin. Do main includes and create new instance for plugin components
 *
 * @author Eoxia <dev@eoxia.com>
 * @version 1.3.0.1
 */

if ( !defined( 'ABSPATH' ) ) exit;

/** Define */
DEFINE( 'WPEOMTM_TASK_VERSION', '1.3.0.1' );
DEFINE( 'WPEOMTM_TASK_DIR', basename( dirname( __FILE__ ) ) );
DEFINE( 'WPEOMTM_TASK_PATH', str_replace( "\\", "/", plugin_dir_path( __FILE__ ) ) );
DEFINE( 'WPEOMTM_TASK_URL', str_replace( str_replace( "\\", "/", ABSPATH), site_url() . '/', WPEOMTM_TASK_PATH ) );

DEFINE( 'WPEOMTM_TASK_EXPORT_URL', WPEOMTM_TASK_URL . '/asset/export/' );
DEFINE( 'WPEOMTM_TASK_ASSET_URL', WPEOMTM_TASK_URL . '/asset/');
DEFINE( 'WPEOMTM_TASK_EXPORT_DIR',  WPEOMTM_TASK_PATH . '/asset/export/' );
DEFINE( 'WPEOMTM_TASK_ASSETS_DIR',  WPEOMTM_TASK_PATH . '/asset/' );

DEFINE( 'WPEOMTM_TASK_TEMPLATES_MAIN_DIR', WPEOMTM_TASK_PATH . '/template/' );

/** Ajout des langues */
add_action( 'plugins_loaded', function() {
	load_plugin_textdomain( 'task-manager', false, dirname( plugin_basename( __FILE__ ) ) . '/language/' );
} );

require_once( WPEOMTM_TASK_PATH . '/core/wpeo_util.01.php' );
require_once( WPEOMTM_TASK_PATH . '/core/wpeo_template.01.php' );
require_once( WPEOMTM_TASK_PATH . '/core/wpeo_check.01.php' );
wpeo_util::install_in( 'core' );

require_once( WPEOMTM_TASK_PATH . '/controller/task.controller.01.php' );
require_once( WPEOMTM_TASK_PATH . '/controller/task.action.01.php' );
?>